TYPO3 Core - Bug #92733

rebuildSlugsForSlugChange fails when changing slug of a localized root page
2020-10-29 13:55 - Oliver Bartsch

Status: Closed Start date: 2020-10-29
Priority: Should have Due date:

Assignee: Oliver Bartsch % Done: 100%
Target version:
PHP Version: Is Regression:

Tags: Sprint Focus:

Description

Changing a slug of a site with L>0 and pid=0 throws a SiteNotFoundException on save.

That's because rebuildSlugsForSlugChange calls SiteFinder::getSiteByPageld() with the pageld of the localized page. This page
however has pid=0 set.

Therefore, it's not possible find any site configuration, because they are always mapped to the uid of the default page which we can
not determine in this case.

Reproduce: Change the slug field of a localized root page in the page properties and try to save the page record.

Associated revisions

Revision 67dde9c0 - 2020-10-30 13:32 - Oliver Bartsch
[BUGFIX] Use default page id for fetching a site in SlugService

The rebuildSlugsForSlugChange function of SlugService updates
slugs of sub pages and also creates redirects for them, after
changing the slug of their parent page. This process requires

to fetch the corresponding site configuration.

In cases like changing the slug of a localized root page
this throws a SiteNotFoundException, because the site is
always mapped to the default page id which can not be
determined for localized root pages because their pid is 0.

It's therefore necessary to always use the default page
id for fetching the site through SiteFinder.

Resolves: #92733

Releases: master, 10.4

Change-Id: 18b41647d63d444982b2d2d6f209dea4278034488
Reviewed-on: https://review.typo3.org/c/Packages/TYPO3.CMS/+/66353
Tested-by: TYPO3com <noreply@typo3.com>

Tested-by: Benni Mack <benni@typo3.org>

Tested-by: Andreas Fernandez <a.fernandez@scripting-base.de>
Reviewed-by: Benni Mack <benni@typo3.org>

Reviewed-by: Andreas Fernandez <a.fernandez@scripting-base.de>

Revision 8b191e58 - 2020-10-30 14:21 - Oliver Bartsch
[BUGFIX] Use default page id for fetching a site in SlugService

The rebuildSlugsForSlugChange function of SlugService updates
slugs of sub pages and also creates redirects for them, after
changing the slug of their parent page. This process requires

to fetch the corresponding site configuration.

In cases like changing the slug of a localized root page
this throws a SiteNotFoundException, because the site is
always mapped to the default page id which can not be
determined for localized root pages because their pid is 0.
It's therefore necessary to always use the default page
id for fetching the site through SiteFinder.

Resolves: #92733

Releases: master, 10.4

Change-Id: 18b41647d63d444982b2d2d6f209dea4278034488
Reviewed-on: https://review.typo3.org/c/Packages/TYPO3.CMS/+/66341
Tested-by: TYPO3com <noreply@typo3.com>

Tested-by: Andreas Fernandez <a.fernandez@scripting-base.de>
Reviewed-by: Andreas Fernandez <a.fernandez@scripting-base.de>

History

#1 - 2020-10-29 13:55 - Oliver Bartsch

- Subject changed from rebuildSlugsForSlugChange fails when changing slug of a localized site root to rebuildSlugsForSlugChange fails when
changing slug of a localized root page

#2 - 2020-10-29 14:25 - Gerrit Code Review

- Status changed from New to Under Review

Patch set 3 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/c/Packages/TYPO3.CMS/+/66353

#3 - 2020-10-29 15:00 - Gerrit Code Review

Patch set 4 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/c/Packages/TYPO3.CMS/+/66353

#4 - 2020-10-30 13:33 - Gerrit Code Review

Patch set 1 for branch 10.4 of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/c/Packages/TYPO3.CMS/+/66341

#5 - 2020-10-30 14:00 - Oliver Bartsch
- Status changed from Under Review to Resolved

- % Done changed from 0 to 100

Applied in changeset 67dde9c018909997833f50d1b4deeb48dede1770.

#6 - 2020-12-22 11:03 - Benni Mack

- Status changed from Resolved to Closed
